<template>
  <div>
    <!--查询区域-->
    <div class="jeecg-basic-table-form-container">
      <a-form @keyup.enter.native="searchQuery" :model="queryParam" :label-col="labelCol" :wrapper-col="wrapperCol">
        <a-row :gutter="24">
          <a-col  :lg="12">
            <a-form-item  label="当前地址">
              <a-input placeholder="请输入当前地址" v-model:value="queryParam.url" disabled="true"></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12">
            <a-form-item label="当前地址状态">
              <a-input placeholder="请输入当前地址状态" v-model:value="queryParam.stateUrl"></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12">
            <a-form-item label="当前地址类型">
              <a-input placeholder="请输入当前地址类型" v-model:value="queryParam.typeUrl"></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12">
            <a-form-item label="父地址">
              <a-input placeholder="请输入父地址" v-model:value="queryParam.source"></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12">
            <a-form-item label="父地址类型">
              <a-input placeholder="请输入父地址类型" v-model:value="queryParam.typeSource"></a-input>
            </a-form-item>
          </a-col>
          <template v-if="toggleSearchStatus">

            <a-col :lg="12">
              <a-form-item label="父地址状态">
                <a-input placeholder="请输入父地址状态" v-model:value="queryParam.stateSource"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="12">
              <a-form-item label="信息">
                <a-input placeholder="请输入信息" v-model:value="queryParam.message"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="12">
              <a-form-item label="主站点链接">
                <a-input placeholder="请输入主站点链接" v-model:value="queryParam.mainUrl"></a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="12">
              <a-form-item label="创建时间">
                <a-date-picker value-format="YYYY-MM-DD" placeholder="请选择开始时间" v-model:value="queryParam.saveTime_begin" class="query-group-cust"/>
                <span class="query-group-split-cust">~</span>
                <a-date-picker value-format="YYYY-MM-DD" placeholder="请选择结束日期" v-model:value="queryParam.saveTime_end" class="query-group-cust"/>
              </a-form-item>
            </a-col>
            <a-col :lg="12">
              <a-form-item label="更新时间">
                <a-date-picker value-format="YYYY-MM-DD" placeholder="请选择开始时间" v-model:value="queryParam.updateTime_begin" class="query-group-cust"/>
                <span class="query-group-split-cust">~</span>
                <a-date-picker value-format="YYYY-MM-DD" placeholder="请选择结束日期" v-model:value="queryParam.updateTime_end" class="query-group-cust"/>
              </a-form-item>
            </a-col>
          </template>
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
            <span style="float: left; overflow: hidden" class="table-page-search-submitButtons">
              <a-col :lg="6">
                <a-button type="primary" preIcon="ant-design:search-outlined" @click="searchQuery">查询</a-button>
                 <a @click="toggleSearchStatus = !toggleSearchStatus" style="margin-left: 8px">
                  {{ toggleSearchStatus ? '收起' : '展开' }}
                  <Icon :icon="toggleSearchStatus ? 'ant-design:up-outlined' : 'ant-design:down-outlined'" />
                </a>
              </a-col>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!--操作栏-->
      <template #action="{ record }">
        <TableAction  :dropDownActions="getDropDownAction(record)"/>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <ExternalInternalSiteModal ref="registerModal" @success="handleSuccess"></ExternalInternalSiteModal>
  </div>
</template>

<script lang="ts" name="externalinternalsite-externalInternalSite" setup>
  import { ref, reactive } from 'vue';
  import {defHttp} from '/@/utils/http/axios';
  import { BasicTable} from '/@/components/Table';
  import { useTable} from '/@/components/Table';
  import {TableAction } from '/@/components/Table';
  import { useListPage } from '/@/hooks/system/useListPage';
  import { columns } from './ExternalInternalSite.data';
  import { list, deleteOne, batchDelete, getImportUrl, getExportUrl } from './ExternalInternalSite.api';
  import { downloadFile } from '/@/utils/common/renderUtils';
  import ExternalInternalSiteModal from './components/ExternalInternalSiteModal.vue'
  import {useRouter} from "vue-router";

  const queryParam = ref<any>({});
  const toggleSearchStatus = ref<boolean>(false);
  const registerModal = ref();
  const router = useRouter();
  const props = defineProps({
    //子组件接收父组件传递过来的值
    lickSet: String,
    outLinkSysSetId: String,
    outLinkSysSetName: String,
  })
  queryParam.value.url = props.lickSet;
  //注册table数据
  const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
    tableProps: {
      title: '扫描链接表',
      api: list,
      columns,
      canResize:false,
      useSearchForm: false,
      actionColumn: {
        width: 120,
        fixed: 'right',
      },
      beforeFetch: (params) => {
        return Object.assign(params, queryParam.value);
      },
    },
    exportConfig: {
      name: "扫描链接表",
      url: getExportUrl,
    },
	  importConfig: {
	    url: getImportUrl,
	    success: handleSuccess
	  },
  });
  const [registerTable, { reload, collapseAll, updateTableDataRecord, findTableDataRecord, getDataSource }, { rowSelection, selectedRowKeys }] = tableContext;
  const labelCol = reactive({
    xs: { span: 24 },
    sm: { span: 7 },
  });
  const wrapperCol = reactive({
    xs: { span: 24 },
    sm: { span: 16 },
  });
  /**
   * 新增事件
   */
  function handleCrawling() {
    defHttp.get({
      url:'/externalinternalsite/externalInternalSite/listCrawling',
      timeout:100000,
    }).then((res)=>{
      reload()
    })
  }
  /**
   * 新增事件
   */
  function handleAdd() {
    registerModal.value.disableSubmit = false;
    registerModal.value.add();
  }

  /**
   * 编辑事件
   */
  function handleEdit(record: Recordable) {
    registerModal.value.disableSubmit = false;
    registerModal.value.edit(record);
  }

  /**
   * 详情
   */
  function handleDetail(record: Recordable) {
    registerModal.value.disableSubmit = true;
    registerModal.value.edit(record);
  }

  /**
   * 删除事件
   */
  async function handleDelete(record) {
    await deleteOne({ id: record.id }, handleSuccess);
  }

  /**
   * 批量删除事件
   */
  async function batchHandleDelete() {
    await batchDelete({ ids: selectedRowKeys.value }, handleSuccess);
  }

  /**
   * 成功回调
   */
  function handleSuccess() {
    (selectedRowKeys.value = []) && reload();
  }

  /**
   * 操作栏
   */
  function getTableAction(record) {
    return [
      {
        label: '编辑',
        onClick: handleEdit.bind(null, record),
      },
    ];
  }
  /**
   * 实时定位
   */
  function realTimeEdit(record: Recordable) {
    const url = router.resolve({
      path: '/MyIndexLink/'+record.id
    });
    window.open(url.href);
  }
  /**
   * 实时定位
   */
  function oldTimeEdit(record: Recordable) {
    const url = router.resolve({
      path: '/MyIndexOldLink/'+record.id
    });
    window.open(url.href);
  }
  /**
   * 下拉操作栏
   */
  function getDropDownAction(record) {
    return [
      {
        label: '实时定位',
        onClick: realTimeEdit.bind(null, record),
      },
      {
        label: '编辑',
        onClick: handleEdit.bind(null, record),
      },
      {
        label: '详情',
        onClick: handleDetail.bind(null, record),
      }, {
        label: '删除',
        popConfirm: {
          title: '是否确认删除',
          confirm: handleDelete.bind(null, record),
        }
      }
    ]
  }

  /**
   * 查询
   */
  function searchQuery() {
    reload();
  }

  /**
   * 重置
   */
  function searchReset() {
    queryParam.value = {};
    selectedRowKeys.value = [];
    //刷新数据
    reload();
  }




</script>

<style lang="less" scoped>
  .jeecg-basic-table-form-container {
    .table-page-search-submitButtons {
      display: block;
      margin-bottom: 24px;
      white-space: nowrap;
    }
    .query-group-cust{
      width: calc(50% - 15px);
      min-width: 100px !important;
    }
    .query-group-split-cust{
      width: 30px;
      display: inline-block;
      text-align: center
    }
  }
</style>
